#include "itext.h"
#include "xtext.h"
#include "xjp.h"

static int _end_char(ITEXT_T *);
static int _start_char(ITEXT_T *);
static int _k_char(ITEXT_T *);
static int _y_char(ITEXT_T *);
static int _h_char(ITEXT_T *);

static int _end_char(ITEXT_T *it)
{
	if(it == NULL) return -1;
	if(it->c1 == 0xa1){
		if(	it->c2 == 0xa2 		||
		  	it->c2 == 0xa3 		|| 
			it->c2 == 0xd1		||
			it->c2 == 0xd3		||
			it->c2 == 0xd5		||
			it->c2 == 0xd7		||
			it->c2 == 0xd9		||
			it->c2 == 0xcb		||
			it->c2 == 0xcd		||
			it->c2 == 0xcf		){

			return 1;
		}
	}
	return 0;
}
static int _start_char(ITEXT_T *it)
{
	if(it == NULL) return -1;
        if(it->c1 == 0xa1){
		if(	it->c2 == 0xca		||
			it->c2 == 0xcc		||
			it->c2 == 0xce		||
			it->c2 == 0xd0		||
			it->c2 == 0xd2		||
			it->c2 == 0xd4		||
			it->c2 == 0xd6		||
			it->c2 == 0xd8		||
			it->c2 == 0xda		){
			return 1;
		}
	}
	return 0;
}
static int _k_char(ITEXT_T *it)
{
	if(it == NULL) return -1;
	if(it->c1 >= 0xb0) return 1;
	return 0;
}
static int _y_char(ITEXT_T *it)
{
	if(it == NULL) return -1;
	if(it->c1 == 0xa4 || it->c1 == 0xa5){
		if(	it->c2 == 0xa1		||
			it->c2 == 0xa3		||
			it->c2 == 0xa5		||
			it->c2 == 0xa7		||
			it->c2 == 0xa9		||
                        it->c2 == 0xc3		||
                        it->c2 == 0xe3		||
			it->c2 == 0xe5		||
			it->c2 == 0xe7		||
			it->c2 == 0xee		){
			return 1;
		}
	}
	return 0;
}
static int _h_char(ITEXT_T *it)
{
	if(it == NULL) return -1;
	if(it->c1 == 0xa1){
		if(	it->c2 == 0xc4		||
			it->c2 == 0xc5		){
			return 1;
		}
	}
	return 0;
}
int xtext_prev_kuten(ITEXT_T *it,char_data_t *ct,int level)
{
        if(it == NULL) return -1;
	if(level == 0) return 0;
	if(level == 2){
		if(it->prev->c1 == 0xa1){
	       		if(	it->prev->c2 == 0xa2	||
				it->prev->c2 == 0xa3	){
				return 1;
	       		}
		}
		if(_k_char(it)){
			if(!_k_char(it->prev) && _k_char(it->next)) return 1;
		}
	}
	if(_start_char(it)) return 1;

        return 0;
}
int xtext_next_kuten(ITEXT_T *it,char_data_t *ct,int level)
{
        ITEXT_T *n;
        int c;

        if(it->next == NULL) return -1;
	if(level == 0) return 0;
	if(_end_char(it)){
	       if(_end_char(it->next))
		       return 1;
	       else
		       return 0;
	}
	if(level == 2){
		if(_k_char(it)){
			for(n=it,c=0;n!=NULL;n=n->next,c++){
				if(!_k_char(n)) break;
			}
			if(c < ct->draw->char_footer) return 1;
		}
		if(_y_char(it)){
			for(n=it,c=0;n!=NULL;n=n->next,c++){
				if(!_y_char(n)) break;
			}
			if(c < ct->draw->char_footer) return 1;
		}
		/*
		if(_h_char(it)){
			for(n=it,c=0;n!=NULL;n=n->next,c++){
				if(!_h_char(n)) break;
			}
			if(c < CHAR_FOOTER) return 1;
		}
		*/
	}

        for(n=it,c=0;n!=NULL;n=n->next,c++){
		if(_end_char(n)) break;
	}

        if(c < ct->draw->char_footer) return 1;

        n = it->next;
        if(n->c1 == 0xa1){
                switch(n->c2){
			case 0xa0:case 0xa1:case 0xa2:
			case 0xa3:case 0xa4:case 0xa5:
			case 0xa6:case 0xa7:case 0xa8:
			case 0xa9:
                        case 0xb2:case 0xb3:case 0xb4:
			case 0xb5:case 0xb6:case 0xb7:
			case 0xb8:case 0xb9:case 0xba:
			case 0xbb:case 0xbc:case 0xbd:
			case 0xbe:case 0xbf:
                        case 0xc0:case 0xc1:case 0xc2:
			case 0xc3:case 0xc4:case 0xc5:
			case 0xc6:case 0xc7:case 0xc8:
			case 0xc9:case 0xcb:case 0xcd:
			case 0xcf:
                        case 0xd1:case 0xd3:case 0xd5:
			case 0xd7:case 0xd9:case 0xda:
			case 0xdb:case 0xdc:case 0xdd:
			case 0xde:case 0xdf:
			case 0xe4:case 0xe6:
	                         return 1;
                         break;
                 }
        }else if(n->c1 == 0xa4 || n->c1 == 0xa5){
                switch(n->c2){
                        case 0xa1:case 0xa3:case 0xa5:
			case 0xa7:case 0xa9:
                        case 0xc3:
                        case 0xe3:case 0xe5:case 0xe7:
			case 0xee:
                                return 1;
                        break;
                }
        }

        return 0;
}
/* ---- 2.8.5 ------- */
static int _is_kako(ITEXT_T *it)
{
	if( it == NULL ) return 0;

	if( it->c1 != 0xa1 ) return 0;

	if( it->c2 >= 0xca && it->c2 <= 0xd9)
		return 1;
	if( it->c2 == 0xda || it->c2 == 0xdb )
		return 1;

	return 0;
}
static int _is_kuten(ITEXT_T *it)
{
	int type;

	if( it == NULL ) return 0;

	type = xtext_check_image_data(it);
	if(type == 2) return 1;

	return 0;
}
static int _is_yon(ITEXT_T *it)
{
	int type;

	if( it == NULL ) return 0;

	type = xtext_check_image_data(it);
	if(type == 5) return 1;

	return 0;
}
/* ----------------- */
int xtext_get_low_space(ITEXT_T *it,char_data_t *ct)
{
        int h,cs;

	if(it == NULL) return 0;

	cs = ct->charSize;

	if( !ChFlag(it->flag,_EJC) ){
		cs = ct->charSize_e;
	}
	if(ChFlag(it->flag,_SML)){
		cs = ct->charSize_s;
	}

	h = cs + ct->ypad;
	if( _is_kuten(it) ) h -= cs  / 2;
	if( _is_yon(it) ) h -= cs  / 3;
	if( _is_kako(it)) h -= cs / 3;


	if(ChFlag(it->flag,_KUN)){
		ITEXTR_T *kt;

		for(kt=it->chu_head;kt!=NULL;kt=kt->next){
			if(kt->c1 == 0xa1 && kt->c2 == 0xf4) continue;
			if(kt->c1 == 0xa1 && kt->c2 == 0xca) continue;
			if(kt->c1 == 0xa1 && kt->c2 == 0xcb) continue;
	       		h = h + ct->charSize_r;
		}
	}
	if(it->chu_string != NULL) h = h + ct->charSize_r;

        return h;
}
int xtext_get_low_pos(ITEXT_T *it,char_data_t *cd,int y0)
{
	ITEXT_T *t;
	int i,y,m;

	if(it == NULL) return 0;

	if(ChFlag(it->flag,_LST)){
		i = 0;
		for(t=it->next;t!=NULL;t=t->next)
			i++;

		GetFlag(it->flag,m);

		y = (cd->draw->end_low) - ((m-1) * (cd->charSize + cd->ypad)) - (i * (cd->charSize + cd->ypad));

	}else if(ChFlag(it->flag,_TOP)){

		GetFlag(it->flag,m);
		y = (m - 1 + 1) * (cd->charSize + cd->ypad);

	}
	if(y < 0) y = (cd->draw->char_header) * (cd->charSize);
	if(y < y0) y = y0;

	return y;
}
