#include "itext.h"
#include "xtext.h"

static chu_data_t *chead = NULL, *ctail = NULL;
static chu_data_t * _chumessage_data_alloc();
static void _chumessage_data_free(chu_data_t **,chu_data_t **);
static void _chumessage_data_add(chu_data_t **,chu_data_t **,chu_data_t *);

static chu_data_t * _chumessage_data_alloc()
{
	chu_data_t *ct;

	if((ct = (chu_data_t *)malloc(sizeof(chu_data_t))) == NULL){
		fprintf(stderr,"Error: _chumeesage()(malloc() xtext_f5(14)\n");
	       	return NULL;
	}; 
	ct->message[0] = '\0';

	return ct;
}
static void _chumessage_data_free(chu_data_t **head,chu_data_t **tail)
{
	chu_data_t *ct,*ctt;

	for(ct = *head;ct != NULL;ct = ctt){ 
		ctt = ct->next; 
		free(ct); 
	}
	*head = NULL; *tail = NULL;

	return;
}
static void _chumessage_data_add(chu_data_t **head,chu_data_t **tail,chu_data_t *im)
{
        if(*tail){im->next = NULL; im->prev = *tail;(*tail)->next = im;*tail = im;}
        else{ im->next = NULL;im->prev = NULL;*tail = im;*head = im;}
}
int xtextClearChuWindow(Display *disp,my_window_t *win)
{
	if(win == NULL) return -1;
	XClearWindow(disp,win->mwin);

	if(chead == NULL) return 0;
	_chumessage_data_free(&chead,&ctail);

	return 0;
}
int xtextDrawChuMessage(Display *disp,my_window_t *win,char_data_t *cd,int step)
{
	chu_data_t *ct;

	Window root;
	XRectangle ink,log;
	char *p,*pp,temp[256];
	int wx,wy,bw,depth; 
	int max,w,h;
	int i,x,y,ypos; 
	int flag;
	int CSIZE,YSIZE;
	
	CSIZE = cd->charSize;
	YSIZE = CSIZE + 5;
	ypos = CSIZE + 2;

	XClearWindow(disp,win->mwin);
	if(chead == NULL) return step;

	XGetGeometry(disp,win->mwin,&root,&wx,&wy,&w,&h,&bw,&depth);
	/*
	w = win->mwidth;
	h = win->mheight;
	*/

	x = 1; 
	y = step /* +YSIZE */; 
	max = (w / CSIZE) * 2 - (CSIZE/2);

	for(ct=chead;ct!=NULL;ct=ct->next){
		pp = ct->message;
		while(1){
			flag = 0; 
			y = y + ypos;

			for(p=pp,i=0;*p;p++,i++){

				if( *p & 0x80 ) flag = flag ? 0 : 1;

				if( i >= max ){
					if(flag == 0) temp[i++] = *(p++);
				       	break;
				}
				temp[i] = *p;
			}
			temp[i] = '\0'; 

			XmbTextExtents(win->fs_s,temp,i,&ink,&log);
			if( log.width >= w ){
				fprintf(stderr,"Error: xtext_f5.c(100)\n");
				fprintf(stderr,"w:%d ink:%d log:%d\n",w,ink.width,log.width);
				fprintf(stderr,"%s\n",temp);
				break;
			}
			XmbDrawString(disp,win->mwin,win->fs_s,win->fgc,x,y,temp,i);

			if(i<max)
				break;
			else
				pp = p;
		}
	}

	/*
	XClearArea(disp,win->mwin,0,0,win->mwidth,YSIZE,0);
	*/

	if( y < h )
		step = step + cd->step_per_pixel;
	if( step >= 0 )
		step = cd->step_per_pixel * -1;


	return step;
}
int xtextChuMessage(Display *disp,my_window_t *win,char_data_t *cd,char *message)
{
	chu_data_t *ct;

	if((ct = (chu_data_t *)_chumessage_data_alloc()) == NULL){
		fprintf(stderr,"Error: chumessage xtext_f5.c(82)\n");
		return -1;
	}

	strcpy(ct->message,message);
	_chumessage_data_add(&chead,&ctail,ct);

	xtextDrawChuMessage(disp,win,cd,0);

	return 0;
}
